/*	SCCS Id: @(#)japanese.c	3.4	2003/12/02	*/
/* Copyright (c) Stichting Mathematisch Centrum, Amsterdam, 1985. */
/* NetHack may be freely redistributed.  See license for details. */

#include "hack.h"

#if ('01' == 0x3031)
# define KCONST(x) x
#else
# define KCONST(x) (((x)>>8)|(((x)&0xff)<<8))
#endif

STATIC_DCL int FDECL(jgetword, (const char *));
STATIC_DCL const char *FDECL(jindex_n, (const char *, int));
STATIC_DCL boolean FDECL(head_kinsoku, (const char *));
STATIC_DCL int FDECL(kanji2index, (unsigned char, unsigned char));

static char jbuf[BUFSZ];

static const char *ro0, *ro1, *ro2;

/*
 * c1 偺屻傠晹暘偑 c2 偲堦抳偡傞偐傪斾妑
 */
int
strcmpr(c1, c2)
const char *c1, *c2;
{
	int l1, l2;
	l1 = strlen(c1);
	l2 = strlen(c2);
	if (l1 < l2) return 1;
	return strcmp(c1 + l1 - l2, c2);
}

/*
 * 堷悢偑娍帤(偺1暥帤栚)偐偳偆偐傪挷傋傞
 */
int
is_kanji(c)
unsigned char c;
{
#if (('亖')==0x8181)
	/* SJIS */
	c ^= 0x20;
	c -= 0xa1;
	return (c <= 0x3b);
#else
	/* EUC */
    	return !!(c & 0x80);
#endif
}

/*
 * 慡妏暥帤偺偆偪丄object偺柤慜偵巊傢傟傞壜擻惈偑偁傞傕偺傪敿妏偵曄姺
 */
void ztoh(str)
char *str;
{
    static const char *z = "侽侾俀俁係俆俇俈俉俋乮乯亹丗亄亅俿";
    static const char *h = "0123456789()$:+-T";
    int i, k;
    char *p, *q;
    q = str;
    while ((k = (int)((unsigned char)(*str))) != 0) {
	if (is_kanji(k)) {
	    k <<= 8;
	    k |= (int)((unsigned char)(str[1]));
	    p = jindex_n(z, k);
	    if (p) {
		i = (p - z)/2;
		*q++ = h[i];
		str += 2;
	    } else {
		*q++ = *str++;
		*q++ = *str++;
	    }
	} else {
	    *q++ = *str++;
	}
    }
    *q = 0;
}

const char *kansuji = "乑堦擇嶰巐屲榋幍敧嬨廫";
const char *zensuji = "侽侾俀俁係俆俇俈俉俋";
const char *josushi = "偮屄枃敪杮時氜姫嶜";

char *
jatoi(str, pcnt)
char *str;
int *pcnt;
{
    int i, k, cnt;
    int need_josushi;
    char *p, *s;

    s = str;
    cnt = 0;
    need_josushi = 0;
    while ((k = (int)((unsigned char)(*s))) != 0) {
	if (is_kanji(k)) {
	    k <<= 8;
	    k |= (int)((unsigned char)(s[1]));
	    if ((p = jindex_n(kansuji, k)) != 0) {
		i = (p - kansuji)/2;
		if (i == 10 && cnt) i = 0;
		cnt = cnt * 10 + i;
		s += 2;
		need_josushi = 1;
	    } else if ((p = jindex_n(zensuji, k)) != 0) {
		i = (p - zensuji)/2;
		cnt = cnt * 10 + i;
		s += 2;
	    } else if (jindex_n(josushi, k) &&
		       !strncmp(&s[2], "偺", 2)) {
		s += 4;
		need_josushi = 0;
		break;
	    } else
		break;
	} else if (k >= '0' && k <= '9') {
	    cnt = cnt * 10 + k - '0';
	    s++;
	} else
	    break;
    }
    if (need_josushi) return str;
    *pcnt = cnt;
    return s;
}

const char *
jindex_n(str, wc)
const char *str;
int wc;
{
    int k;
    while ((k = (int)((unsigned char)(*str++))) != 0) {
	if (is_kanji(k)) {
	    k <<= 8;
	    k |= (int)((unsigned char)(*str++));
	    if (k == wc) return (str-2);
	} else {
	    if (k == wc) return (str-1);
	}
    }
    return (const char *)0;
}

/* 僆僽僕僃僋僩偵懳墳偡傞彆悢帉傪曉偡 */
const char *
jjosushi(otmp)
struct obj *otmp;
{
	int otyp = otmp->otyp;
	const char *unitn = (otmp->quan < 10) ? "偮" : "屄";
	switch (otmp->oclass) {
	    case COIN_CLASS:
		unitn = "枃";
		break;
	    case WEAPON_CLASS:
		switch (otyp) {
		    case SHURIKEN:	unitn = "枃"; break;
		    case BULLET:	unitn = "敪"; break;
		    default:		unitn = "杮"; break;
		}
		break;
	    case POTION_CLASS:
		unitn = "時";
		break;
	    case SCROLL_CLASS:
		unitn = "姫";
		break;
	    case TOOL_CLASS:
		switch (otyp) {
		    case LEASH:
		    case MAGIC_CANDLE:
		    case TALLOW_CANDLE:
		    case WAX_CANDLE:	unitn = "杮"; break;
		}
		break;
	    default:
		break;
	}
	return unitn;
}

/* str 偺嵟弶偺暥帤偑峴摢嬛懃張棟偺懳徾偐偳偆偐傪挷傋傞 */
boolean
head_kinsoku(str)
const char *str;
{
    int i, k;
    k = (int)((unsigned char)(*str));
    if (is_kanji(k)) {
	k <<= 8;
	k |= (int)((unsigned char)(str[1]));
	if (k >= KCONST('丄') && k <= KCONST('亃')) {
	    /* 嬪撉揰側偳偺婰崋偼張棟偡傞偑丄奐妵屖偼嫋壜 */
	    return !jindex_n("乪乬乮乲乵乷乹乻乽亀亂", k);
	}
	if (k >= KCONST('偀') && k <= KCONST('傚')) {
	    /* 彫暥帤偼嬛懃張棟偡傞 */
	    return !!jindex_n("偀偂偅偉偋偭傖傘傚", k);
	}
	if (k >= KCONST('傽') && k <= KCONST('儢')) {
	    /* 彫暥帤偼嬛懃張棟偡傞 */
	    return !!jindex_n("傽傿僁僃僅僢儍儏儑儠儢", k);
	}
	return FALSE;
    } else {
	if (k == ')' || k == ']')
	    return TRUE;
    }
    return FALSE;
}

/*
 * 擔杮岅偺暥復偺愗傟栚傪扵偡
 * 愗傟栚偲傒側偡偺偼
 *	傂傜偑側仺傂傜偑側埲奜
 *	敿妏	仺慡妏
 *	慡妏	仺敿妏
 *	'丒'偺捈屻
 *	敿妏僗儁乕僗丄僞僽
 */
int jgetword(str)
const char *str;
{
	boolean ishira = FALSE;
	boolean iszen  = FALSE;
	boolean isspc  = FALSE;
	boolean isnum  = FALSE;
	int len = 0;
	int k;
	while (*str) {
	    if (!is_kanji(*str)) {
		char c;
		c = *str;
		if (c == ' ' || c == '\t') {
		    if (!isspc && len) return len;
		    isspc = TRUE;
		} else
		    isspc = FALSE;
		isnum = (c >= '0' && c <= '9');
		if (iszen && !head_kinsoku(str)) return len;
		str++;
		len++;
	    } else {
		if (!iszen && len && !isnum) return len;
		iszen = TRUE;
		k =  (int)((unsigned char)(*str++)) << 8;
		k |= (int)((unsigned char)(*str++));
		if ((isnum && k == KCONST('奒')) || /* "10奒" 傪悢帤偺捈屻偱愗傜側偄 */
		    (k == KCONST('乕'))) { /* 挿壒婰崋偼捈慜偺慡妏暥帤庬偲摨偠偲傒側偡 */
		} else if (k == KCONST('丒')) {
		    /* 拞揰偺捈屻偼愗傟栚 */
		    return (len+2);
		} else if (k >= KCONST('偀') && k <= KCONST('傫')) {
		    /* 傂傜偑側 */
		    ishira = TRUE;
		} else {
		    /* 傂傜偑側仺傂傜偑側埲奜 偼愗傟栚 */
		    if (ishira) return len;
		}
		len += 2;
		isnum = FALSE;
	    }
	}
	return len;
}
/*
 * 巰場偺暥復傪(maxlen亊4峴)偵惍宍偡傞
 */
char *jget_epitaph(line)
int line;
{
    return &jbuf[line * 64];
}
void jprepare_epitaph(str, maxlen)
const char *str;
int maxlen;	/* 63埲壓 */
{
    int sep[64];
    int idx = 0;
    int i, l;
    int len, line, trycnt;
    const char *p;
    char *buf;
    p = str;
    while (*p) {
	l = jgetword(p);
	sep[idx++] = l;
	p += l;
	if (idx >= 64) break;
    }
    for (trycnt = 0; trycnt < 4; trycnt++) {
	/* 4峴偺嬻暥帤楍偵弶婜壔 */
	for (line=0; line<4; line++) {
	    buf = jget_epitaph(line);
	    *buf = 0;
	}
	/* 曟旇柫傪惍宍 */
	p = str;
	for (i=0, line=0; line<4; line++) {
	    len = 0;
	    buf = jget_epitaph(line);
	    while (len < maxlen) {
		l = sep[i];
		/* 峴摢偺敿妏僗儁乕僗偼彍嫀 */
		while (len==0 && *p==' ') {
		    p++;
		    l--;
		}
		/* 僞僽傪彍嫀(扨岅偺嬫愗傝傪柧帵揑偵巜掕偡傞応崌偵巊梡) */
		while (*p=='\t') {
		    p++;
		    l--;
		}
		while ( (len==0 && l>maxlen) || /* 堦峴偵廂傑傜側偄挿偄僩乕僋儞傑偨偼 */
			(line < trycnt && (len + l > maxlen))) { /* n峴栚傑偱偼愗傟栚傪柍帇偟偰擖傟傞 */
		    boolean iszen = FALSE;
		    while (len < maxlen) {
			if (is_kanji(*p)) {
			    if (len <= (maxlen-2)) {
				buf[len++] = *p++;
				buf[len++] = *p++;
				l -= 2;
				iszen = TRUE;
			    } else break;
			} else {
			    buf[len++] = *p++;
			    l--;
			    iszen = FALSE;
			}
		    }
		    if (head_kinsoku(p)) {
			/* 堦墳嬛懃張棟 */
			if (iszen) {
			    len -= 2;
			    p -= 2;
			    l += 2;
			} else {
			    len--;
			    p--;
			    l++;
			}
		    }
		    buf[len] = 0;
		    len = 0;
		    if (++line >= 4) break;
		    buf = jget_epitaph(line);
		}
		if (len + l <= maxlen) {
		    /* 僩乕僋儞傪媗傔偰偄偔 */
		    strncpy(&buf[len], p, l);
		    p += l;
		    len += l;
		    i++;
		    if (i >= idx) {
			/* 媗傔廔傢偭偨 */
			buf[len] = 0;
			return;
		    }
		} else break;
	    }
	    buf[len] = 0;
	}
    }
}

/*
 * 娍帤岎偠傝暥偺暥帤傪徚偡
 */
int kanji2index(c1, c2)
unsigned char c1, c2;
{
#if (('亖')==0x8181)
	/* SJIS */
	if (c1 >= 0xe0) c1 -= 0x40;
	c1 -= 0x81;
	if (c2 >= 0x80) c2--;
	c2 -= 0x40;
	return ((int)c1 * (0xfc - 0x40 + 1 - 1)) + (int)c2;
#else
	/* EUC */
    	return (((int)c1 & 0x7f) - 0x21) * (0x7e - 0x21 + 1) +
	       (((int)c2 & 0x7f) - 0x21);
#endif
}

boolean
jrubout(str, nxt)
unsigned char *str;
int nxt;
{
	int i, j;
	const unsigned char *p;

	for (j=0; j<=nxt;) {
	    i = j;
	    j += is_kanji(str[j]) + 1;
	}
	if (!is_kanji(str[i])) return FALSE;
	j = kanji2index(str[i], str[i+1]);
	     if (j >= 0x0000 && j <= 0x02B1) p = &ro0[j << 2];
	else if (j >= 0x0582 && j <= 0x1116) p = &ro1[(j - 0x0582) << 2];
	else if (j >= 0x1142 && j <= 0x1E7F) p = &ro2[(j - 0x1142) << 2];
	else p = "丠  ";

	if (p[2] != ' ' || p[3] != ' ') p += rn2(2) * 2;
	str[i++] = *p++;
	str[i  ] = *p;

	return TRUE;
}

/* 偺仺偵 偄仺偔 側仺偵
   ex. 椢怓偺 仺 椢怓偵, 惵偄 仺 惵偔, 僗僥僉側 仺 僗僥僉偵
 */
const char *
j_no_ni(str)
const char *str;
{
	char *ss;
	char *sd;
	ss = eos((char *)str) - 2;
	Strcpy(jbuf, str);
	sd = eos(jbuf) - 2;
	if (!strncmp(ss, "偺", 2) ||
	    !strncmp(ss, "側", 2)) {
	    Strcpy(sd, "偵");
	} else if (!strncmp(ss, "偄", 2)) {
	    Strcpy(sd, "偔");
	}
	return jbuf;
}

/*
 * 僟儞僕儑儞柤偺曄姺
 */
static char *jdgnnamp[MAXDUNGEON];
char *jdgnnam(dnum)
int dnum;
{
	if (!jdgnnamp[dnum]) {
	    char *p;
	    p = dungeons[dnum].dname;
	    if	    (!strcmp(p, "The Dungeons of Doom")) p = "塣柦偺戝柪媨";
	    else if (!strcmp(p, "Sokoban"))		 p = "憅屔斣";
	    else if (!strcmp(p, "The Gnomish Mines"))	 p = "僲乕儉偺峼嶳";
	    else if (!strcmp(p, "The Quest"))		 p = "僋僄僗僩";
	    else if (!strcmp(p, "Gehennom"))		 p = "僎僿僫";
	    else if (!strcmp(p, "Fort Ludios"))		 p = "儘乕僨傿僆僗嵲";
	    else if (!strcmp(p, "Vlad's Tower"))	 p = "償儔僪岒偺搩";
	    else if (!strcmp(p, "The Elemental Planes")) p = "惛楈奅";
	    jdgnnamp[dnum] =p;
	}
	return jdgnnamp[dnum];
}

/*-------------------------------------------------------------------------
	慡妏暥帤偺偐偡傟僷僞乕儞
  -------------------------------------------------------------------------*/
static const char *ro0 =
	"                        丒  丒丆丏  丏倢                丒      "
	"            丷丣    乀丣    丱僄儅  乛儊俠()亅乚亅乚            "
	"乚  乥      乨丒丒          乪  乫   (  )            [  ]    {  "
	"}           乹  乺          乽  乿  乮乵乯乶亅倢    亄亅乛乢亅丗"
	"亅  亖乛<    >  亙亖亜亖乣佷丒乨丅  仜亄        亴  並俠倄亖俽乥"
	"俠乥    並乛亗//    亊  俠倎        仚  ()俠仜  仜  <>  仦  僐檨"
	"仩  伻佢仮  伾丳仱  亊丗亖劍亅->亅<-乥伻乥伾亖                  "
	"                            伡佭伣佭伡亖伣亖(    )  偟俰||佨    "
	"                            丱/  /倴亅  亖仺亖<>伾仱僐佭        "
	"                                    乛丵乥丵    倧  仱  亖  亖  "
	"<<亙>>亜/   乣們乣們乨丒    佺                              並俙"
	"並乛||亖乥偭両|)俿亄侕亖乤                  ()俠                "
	"                                            ()俠丩乥佨佢佨伣佢亄"
	"乽伣佨倧丳 /倧俁倧伖                            仮伻俤俁( 佨俴 )"
	"俥佭乽劌俠  ||劎倢  倢  |<  |_  俶倁||倁俠()俥伣俷儊俹  們佨丳乥"
	"俰偟 /乢VV俶乛乢伾乥丳佢                        倧  倢倧    們倢"
	"們  倢亅倧  乥値丒倢丒倢倢|<    値||倰||們  倢倧們倢倢  丷  亄亅"
	"偟||丄  倴vv乛><倴僲亅佢                    傔偍兦丷偟丷丮偭丮偮"
	"乚  傫儔傚  偺傛僇丷偐  僉偝偒  <   偔  |+侕偗  僯乕偙  亄們偝  "
	"l   偟  僫俋偡  幍t+偣  偰倅偦  僫偙偨  俆偮偪      伣乕偮  乕 ("
	"偰  伡  偲  僫  乥偙傔偺傟傢J)僲傛偗偼  偼  偰壋傂  傂  僴彫傆  "
	"傆  乛乢傊  傊  偼傑傎  傎  僉傛7+佪偡偟偺()偟僉偭亄偮亄偭  傝  "
	"丅劌倧忋偆偭偄僲傠  僆傢俈偭偭僅僆偮偺傞傞傫偲僫/v乣            "
	"                                丆亅僼僲僲倢僲倢儙  儚泘劍佦俿佦"
	"亄  劑  僫搧僇  亖劑僉  僲僼僋  僲僋働  僯 ]僐  僫++僒  丣儞僔  "
	"僼恖僗  儎幍僙  丷僲僜  僋儊僞  僫愮僠  丣僲丣僲僣  亖仹僥  乥丷"
	"僩  亄僲亅丵僼儊槼晄    僲丷僴  僴  劌俴僸  僸  丳僲僼  僼  乛乢"
	"僿  僿  劑彫儂  儂  丷僼丼佭佢丷僲丷姳幍亄  劑  劉佦僐佦僐佭僐佭"
	"亖僼倢僲僲儗倢僲僐檨劇僼乽僼僉僄傾僄儔僼丷僲僂  僫劉僋僲        "
	"                        仮伻俤俁乥丳佢伻俥俴俈佢||劎俷亅乥  |<  "
	"/ 乢倁俶||伻僯佭俠()儭劉俥俢>_佢丳乥伾乥亼倧乛乢乥亄佨          "
	"                            |3B                                 "
	"                                                                "
	"                                                                "
	"                                                                "
	"                仮伻凜伣俤俁乥丳凩  俥俴凟  凨  佨偭||倁処  |<  "
	"J|凱俶倁||劎俠()儭劉俥伣( 佨丳乥倴僲亼凮乛乢俴佦偟乥||佦刉刌刔  "
	"刔||乥伣-)  |O劌伡劎                                            "
	"                倧  ( 倧刔剆亅      們亅剈  剓                  "
	"            剝  剆                                  佦  剨  剮  "
	"剮                                                              "
	"        亅  倢                  劆  劅  劆  劅  劅劆劅  劆  劇  "
	"劉  劊  劋  劌  劍  劎  劏  劑  劌  劍  劎  劏  劑  劌  劍  劎  "
	"劏  劑  ";

static const char *ro1 =
	"惣槺垷  彈孿B 壜槼堖庴怱後  彈崌    帷  惣  婽  湨垷壆  壆  嬨擔"
	"梃  屗  嫑嶲栘恏櫴搚戩搇媦  泘櫱彈妿拵朣怘戜巺弡巺  嫑愯滣  孖暷"
	"僱崌泘彈涼墏埨  擔壒埨  栧壒妚埨栘岥恖  洑  僀棫堖  梃  殬堜媩戝"
	"壯彈曡  帵悺璋  壒  堁  擔栜婏      揷  揷嫟懡  巺璋巺梃揷寧埾  "
	"槼  堓  梃  婱  櫡栴# 仈槼  埥  寧  桳  婔  亅  巑僸塿  柶  壯媽"
	"師  槹  嫑庛儉橷俤櫯場  奓  殬戝彈場媩乥怘寚恜  橷  堿  姰  崱塢"
	"媫  壒堳岥悺愇  泘槹丠  檘伿槹  丠  櫯  掜捁婯  屲  愇璋俤佄欴  "
	"嫊  岥奓庉  堁  嫑欀彈榁櫴婛曖  捾儉栧墹懜  擇儉孯  塉塢擟  怘帹"
	"枖  媨楥奓彈宨渃擔墰桼  憊  悈  塱  塯  塸  擳嶮僸暸僸暸墰  峴梃"
	"尵塱嬥橻栭  涼焧敧嶮攏広彫孼尵堈憱滧栧孼壞  櫴  檆  殬逋櫡彈戝怽"
	"泘彈淢惓櫱怱墏  唰  敧岥撔  壩  壩媽壩惣杒擓逋  巺娉朙怓櫱  墍  "
	"逋  嬥敧櫱捁嶮  曽  僔偪惗抝檨  晇氻暷戝渆庡涼怱峛  擔墹墿  嬫寚"
	"嬫焧岺搚岞塇墱  捁  嬫捁嫟桼檆  拞  壩  堄  洐帄堄  堄  酺  媿搚"
	"偰倅墏  惓櫯場怱擔嶮媫  棫擔俿僩僀僸斀  壜  壛樇惣  孿巇椡岥岥伿"
	"媑壛昐氱彈壠娉  昐暘壯搇僐枖揷栘壛栘欶寚壜掦恖  墹壜欴  栘愮壯壠"
	"屌  壔  壜  壛  壗  憪  壥  拵枖尵壥壺  壔奓壛  欴  塉  拵暥変敯"
	"変  庤滣僆  檨桼恇恖夊堭拵変壛奓夊璋怘変壛攏傊/|傊塢妏  岥  婼  "
	"堖  淢夞彫氻枖搚枅  奃  堖  淥滣岥搧屓澕婼搇枅  瀂夲枅  櫴壩揷夘"
	"斾敀巺夛夘  夝  栧  奆  栚  姣檣堝椡梉僩堝  媑  埑娸崷婛崻婛埑  "
	"愇悺寍嶮峴孿尵堝嬥姣崪堝棦  惡崄拵孿搚榡栘巗拵枩嬥奲醏  妐  柤氱"
	"涼妔峀  妎  奺旳堝  攧焧惽  愇璋惽  尒  梡  愒  幵岎嫕  栧奺榄  "
	"擓拞帤  媢嶳敀栘媞暸欥暸孴  棫  寴  揷榡旜  嫑廐塒櫙奞  堈  彫崌"
	"愩  愩  堈  崪  堈  堈  幵奞栚  嫑寴岥廫壴  壺  妚曪栘庨敀橷婽  "
	"塝  晝嬥嬥寭帟  峛捁栘昐柕  愰  媩暷儊儕姞  丠  戩岊僀岥檏尦嫟  "
	"姳儕恟  璋椡屓  汈  恟  彈亪尦  泘岥尒  俿廫戩姳孁  欦  娧  姶  "
	"汈  庢  娒  榡  姱  帵寚璋寚姳  晇  娫  弝  垼  擓  恇嶮栚  姳  "
	"姱  娫  唰  媿嶳戩塇寧姳廙娔姰  璋尒尵搶揷奓垼  娔  栧  栧  栧  "
	"媽  戩梃怘姱鋛姱嬨  崱岥櫴姳尩  墹尦涼昳栚嵂嶳愇廗尦婂  櫴璋尦暸"
	"旻暸尨暸巭  巟  栵  媑  岥戝懘  戝壜婌  婏  嶳巟儊晍涺滪屓怱孯  "
	"栘檣曽懘嵂澸懘寧栘懘栘  婔  涒  娉焧儊焹僔焹涺滣僱嬕壯棝婓  巺屓"
	"丠  晇尒尵屓奓  憱屓幵嬨岝孯怘檣攏婏孼儉孁怽堊  媊  彈巟妿  嫊滣"
	"巟  媈  懘寚媊  僸儅僱巵梤変媊  尵媂媊  櫙  櫙  妚櫙巑岥岊  宊  "
	"栘媑柕  尵媑愇愯栘屵壯  嫀櫯奺  媝  錱俤洠  嬕  僋僗僀嬨僀栘擳  "
	"媦  楥  僐櫡儓怱媮澕栘俆挌  媦  棫  媣壩墹媮寠嬨恎媩媦  媦  巺廫"
	"巺崌乥擔屵僉搚儉洐屆櫡俤嫄  張  庤  嫄栘錱  尵屵懌嫄嬥嫃嫑  屼帵"
	"僋揷槼椆嫓  岥彫嫟  晇  嫪  嫢橸棫孼擓  檨儊椡亪櫡墹懄塊岥廫撣岦"
	"桧  晇  媩拵媩榡嫀  杴怱嫟彫晇  岶澕嫪  孼  墹  晇  嫪  擼櫛椡亪"
	"摨  嫪  懄  嬥桧嫿壒嫿怘宧攏僀櫯媈  櫫橸擔嬆栘亸洐嬪揷仈槻媭墹  "
	"摨  暷愮淇  淇椡搚櫙檆廫嬥涘櫴俿嬕寚嬥寚墹崱椦帵恖儉榏  恇巺嬕  "
	"錈  僱崱嬛  尵淇嬕  慡嬍岥崱嬥嵂僫 L嬶  櫙  櫡儊嬪  墹媣栴嫄屆撓"
	"恎嬫攏嬫攏媢攏嬪栚扷鈁  錱屶怘  寠岺鈁  鈁  鈁  鈁  拞僉愡  嬥愳"
	"洐徰洐弌孅  寠孅悈擔妚壔巺幵寠孿擻  堌  媣暷惣栘巺昳枖栘嬥廐摦  "
	"洑塃廳  尵愳孨梤幵  孨  孿僩壛堖僱  宯  壔崰姧  岥橸屗澕搚墹墹孿"
	"孻  愗  淥渃渆枖巚桼涼  媫  愩帺堈  璋擳嬪澕扷嫗孿  晇  揷孿栟巪"
	"巺  巺枖巺暷幵巺孴  枖搚孻  拵  尵廫尵巪宧尵幵枖枖暸晇捁塢  櫯  "
	"嫑嫗錱娉戩滣幵庤敀曽彫擔峴  慍栘恖働氻檙宊  泘敧巺媑嶮  尵氻擔  "
	"僀媿巊  姫  寶  儓仈搧  墰  愰  殬姫恇搚彈寭淢沅怱  導宯庤  姫  "
	"墰  璋  柎  戝  撿將愇  愇尒巺寧栚帵屗寧栚孼尵寭恇奓幵姳捛  嬥寶"
	"墰  擔暸攏墰阞墰橸僥櫴敀櫴姼涺僼媩尯欦  尨  槼涺墹尒巺尯廙尯嶰岥"
	"尵旻嵂  愮暯屌  愯巑岥屃殬屆彈屆巕塟僐  涼幵媩塟丳洐屆澕栘屆煒層"
	"塟  擲層氿  寧焧屆寧屒  錱橷尵氿懌氿嬥屆屗璋屬暸摛巟墹  淿  屲  "
	"姳働儐岥屲岥彈屶涺氱壍廬彫屷栘屷嬜  墹層懘愇尵屷尵屶尵惽撗層壋  "
	"嫑棦榋晝岎  儐栴儐栴岾  槼橸僴儉岺椡岎椡儉櫙櫴巕檨僐檆岥櫴愇岥岒"
	"搚槾搚岪彈巕巕偟巕搚泘儉俿佦僄枩嫟屓搚恏涼儉涼洑涼璁媩儉彫榡彫峳"
	"槾  嬪  嬻  僄澕擔報擔岝棛  槾  岎  峏  檌  僔岺僔嫟僔崘僔岼僔檌"
	"揷拞掓澺愇峏壯崅暷峃巺岺巺儉巺岎巺壀阄堜搚俆巭寧寧儉寧嬻崅寧廙槾"
	"鋳愳渆仹峴嫑尵檌岺奓奓檌岎B 撗岶嬥峀愇峀嬥壀栧崌氱儛岺暸壯擔槼岦"
	"峕捁壀l|嫀椡岥枩傊岥崑  峫  僔崑壠  幵亪敒櫙屆孼堝  媿媑嫥嬍壯嶦"
	"撗崘崘柭棦  尵將僔幁寧梫慮姠栜怱崥  寧欴敀  擖  巭斾僸暸僿儔場栘"
	"搚怽娑嵂彈崹彫嵂娑嵂巵擔擔斾栘嵂栘崲崺  涼嵂巺娒擔俼塢婼崯僯僀嵍"
	"枖  堯  嶳嵎僫僄愠嵍栘妿僔彮墹嵎愇彮尵撫嬥奓嵐堖搚樃涼嵖嵖  愑  "
	"璋  檉  庢  媑滣婎姦儓彈恏  嵮渃僆挌嵮  栘滣巭愂惸  涊壩壯僣洐媿"
	"愇櫨崯愇梉帵惸帵巺揷嵮  堖滣幵滣B 嵳惸  搚  栘嵥旕  奓嵥夊  斀  "
	"斀  奅  恄  儊桳岥揤嶳婏婏  愇婏楬捁僀撫徰  岥撫嶓  擔嶎洠寧嶜  "
	"寠撫濺  巺  嬥愄栘彈嫑孿悽  惀僸嶮  洐嬓嵳  涊梉嵟  嶡  栘偟壯焧"
	"嶻  櫨璋敀憗嫑惵暿夳嬥惵嫑岎剨||擔惣擇佭槩  儉渃檨佦嶲  嶶  愄澕"
	"栘滣壩暷墹嶜旻惗栚淥嶼巺揤拵巀  晇奓撗堯怘  幵嬕巃擔焑滣廦巑僀巕"
	"巌  僀棛濺  =]  忎拞嶜巌旵岥廫佦彈戜彈巗師彈椆堦洐巰嬓  敀嬓巑怱"
	"揷怱巪  巑枖巕澕懘嬕曽栫僸擔栘巟忋  焑僸[+EE巘  僱巭壯儉涺彫巺巵"
	"崯巺寧巟寧巪儉恜廽尒尵巌尵帥尵幃尵巙尵欬師奓奓堈崯璋怘巌巭暷槶儓"
	"埲  帥  媽橷泘巕搚悺涺怱帥  擔帥寚  涺  栬戜塉  帰嬍涼帥愇帬仹彫"
	"檆  係搇敀栚帪  愩恏僔梉涼斾岺淭鎪嵠揷柭抾擇幵桼寠榋塉壓偟亄岥幍"
	"岾娵栴晇彈幘帄  嵮怱僔擔媜  涼幐嬕奓晇  晹  瀶  捪巚崯栘擵  洕  "
	"恈亪巺崅崌  梌  恎悺幧廍愒澕梋搇幰  僱搚巺彮搚塃摙幩榡戩弾  拵泙"
	"夊  僀愄櫙  洐敧栘庂壩庂嵂悺撗庂壯広嬥堈塃  廸  媩塇庒怱墹  帹枖"
	"悺  恜僉媿  焑庨庣  墹庨壯廳寧廳憱庢撗  帺昐廀  枖  孼  嶰悺庴  "
	"栘媕巺庴塉帶殬恖枖  媑  帵  嫗栟愳乧澘渃廐怱崌  廈  壯擳壯壩巺搤"
	"弆  塇敀帺戝扥  婼  寣  棿  璋尵懌廇幵帹廃  撗  撗廈敼栘撗婼僀廫"
	"巇庡堯  堦亄渆旸滣  柕栘檘廫巭><酼將巺廬愮棦嬥廩儂枖焑  樝  廸  "
	"僱孼巺廻暷  泋  泋  搚嶳峴儃儃  堯  嶳堯擔晇弚  棫堯慍  攏堯璋  "
	"弬  擔嬪弬  焑弡嫕  弝敼塠  岪  巺撛涊  懜  撗嫕愳暸氱檣僱搧屗嬕"
	"擔幰彁  幰  涼擓巺幰幰  沅  彁  彅  尵幰妿椡梋枖偔僲涼梊梋  擛怱"
	"嬥彆梋  濅  徿  寯  櫡嬕僠淥搧岥徰  棫檊徆  彯巪彨戝棫彈彈徆徰  "
	"悺  僴槴彫  岦  涼搚涼栘涼澠復渃椆悈彮  彚  彯庤憱  擔彙擔  擔彚"
	"徆昳栘岞栘徰栘復栘徟彚  徰  曕  煍憡壩嬆璋  徍  涼惓彮栚愇徰愇徟"
	"僱梤壯洉壒憗氼  暷彲巺彚彫寧徆  彨  徟  峴廳彯堖尵岞尵惓尵彚尵梤"
	"娉  彯堳彨撗嬥惓嬥廳嬥摱復  妚徰劌佦僫儊椆悈壯  檏檣忔  惉  濅  "
	"艴  彈艴彯捿惵  桱  氱栘栘忎憟  將  揷妿壯艴忓  尵艴撗艴嬥掕懏  "
	"捈  怘嬓幃  捈  焑捈壩鍐巺嵠帹嵠僋攂妏拵椙  怘拵扖悺洐嬨拠怽尵  "
	"儓枖扖岥彈扖怹  斣  僴偠恀  扖  恏嬕擔  椦亪恅  儓枖忕栘桼峛涼渃"
	"嬶掑僱怽壯  巺怽嫄  怱  怴  恏尒尵渃帺僆棫亸璋  嬥廫塉扖僲傊僀擇"
	"搧  涼  愮巑儓悺懘旵広  恇寧尵  廫  幵  妚恘巌  尵庢渃暸撗撫殬儊"
	"櫴悺摛  岥寚愮怽嬓  璋  僼槴壩寚栚悅暷櫨塇懖垼  娉  撗櫨嬥璋嬥悅"
	"桳  墹帶崪桳嶳廆嶳崅暷澕栘嬫憱鋶鋶璋嫃  栘渃栘徆姱  旂暸彮璋嫃  "
	"搊  廗  挌亄偣擓棅  揷媣擔旸嵢  巗  娵椡彈惗惓  惗  滫  惓澕懇惓"
	"擔惗擔惵栘嵢栘惣巭壓惵  媿惗媿墹惉嶮暷惵帹墹巑洐惂堖巐  尵惉愜尵"
	"尵惵愜  撗惎墹寧惵憟暥  壯孼寧婋璋枖涼嬓彫愄惉儃嬕  擔  栘嬕岥  "
	"愑  抾愄巺愑晇寧墹奓搚枓懌枓懌愑愇暸幍搧弌  彣  帹><嬕  尵焧寠愗"
	"抾懄尵孼塉儓巺怓恜屆拵扨僀嶳媿橸廫僀忋岥榡  桼悺彫戝僲l|扨滣屗塇"
	"扚  栘慡栘扥敀悈滣  愭  櫨  懼  慜  愵  曽旸寠夊抾慜巺愹巺滣梤師"
	"寧愹梉儛廙敧涼  尵慡奓滣懌滣扚  姫  嬥滣嬥愭栧恖嫑梤寧l|梤媑巃  "
	"僞將槩墹僱扨巺慞寧慞暷椥彞慮嶑搚嶳妿愄  敧擔揷擔椦旸妿  旸廩旸懇"
	"愇慯僱妿壯妿暷妿搚巺巺妿嫑壯尵愃妿  嶑  塒  慮  憅  枖  嬈庢崌屗"
	"堖  巑  壯  戝  栘  洐慮櫡嬓暔怱憡怱桼枖涒  愮怽攁  昳栘扷姳嬋擔"
	"扨壥憅  憘  憘  壩昳僋洑涼桼栘栚寠怱暷憘巺岞巺廆帹岞憗  憇  巰淥"
	"憅  昳栘憇堖搚旸揤  憘  嬥憅塉憡攏攁徾  慮  慮  憼  曡  奓慮崘  "
	"懌  懃  奓  嵂櫯帺怱懌  濺嫗懃  岥旸懇  扟  洐鈀奓夲曽栴巺攧槼樃"
	"僱桼娒妿慜  僫巕巕宯廢悺堳  栘悺懛  栫  梉渃戝  懢  尵泙悅  桳  "
	"彈  嵍寧挌  栘泙廙泙栘嵍泙  攏懢攏扨僀杮搚弝暥悺帶悺戙嶳櫪嬓帢  "
	"戜怱擻孎堎滣晇擔晇悈懷  寧戜戅  戜  戙堖戙奓嵂  璁  娉  戙崟嫑廃"
	"僀淭儉岥恖僫抾掜撗惀惀暸婂捁棾  棿  愯憗娉  泘儌儌  広  愇  広  "
	"儓弝墹娉尵儌嬥郪鍐  尵庒帹  嬓  拵徰岥僴岥櫯恗扷岾  櫴  璋悺寧孼"
	"屓嫟嫄枖嶳  栘朁僿岥棦  嫑愥栘懜尵璋淥  憗酼岥晇搚扷扲扷忕栘擔  "
	"晇寚墛  恟  嶳奃栴摛棫帶抾扨巺掕帹  寧扷旸拵尵墑嬥抜殬悺樂  媩扨"
	"暷嬕擔唰樂  俤焧揷椡尵墛捈  栴岥搚栫媩栫帹怱抦擔栫  涼抦壯璋捈  "
	"帄澕拵抦洐梤攏栫拀栘尯揷働TT抾杴抺  娉  壯幐寠帄儂槩彈彜梤栚僉廫"
	"僀拞桼  拞怱桼  広扷栘庡庡  拞  垼堖尵庡撗悺嬥庻攏庡栘塉挅弽幰  "
	"挌  幰  奓  堦槴橷杒廃  岥悽棿  嬓愯嬓挿涼挌媩挌媩挿廃渃渆澕挜  "
	"挍  怽濅戩寧挬  曅悽揷挌栚挍帹怱寧挿寧濅拵悽尵廃尵悽憱彚懌挍嬥挍"
	"俤  挌暸塆敀懇椡曕  栚  寧揤僔傫墹渃擟奓嬥恀搶  沅  戉  栘璋栘捛"
	";g  捛  涼酺酺  壠  栘曣崙滼栘婯揷  愑  栘愇廫鐖捁  巺枖嬥欥栘弔"
	"婱  搚暯垷氣彈廀巺桼僀敧岥嬓嬥庂璋捁槼挌巵  掄  掑  掜  愯奓岥墹"
	"惀  旸  棫嬓涼巵涼掛淢恜挗亸掜  巵  掛  惀  掜  僔挌愇掕僱掑壯掓"
	"巺掗廙掛尵挌尵掗懌掗録  巵  撗戝嬥挌栚  擈  彜  儓悇彜澕彜  敀庂"
	"抾桼彜  嬥彜庛  愜岥嶶  嶶  幵嶶幐  嬥幐嬋嶮搚恀戝  洐  涼愯氼彫"
	"恛  愩娒奓愯幵塢恀暸愯扅暓塢洜焧揳  擔弌塉峛孼  岥搚暔  梋  彈愇"
	"洐幰憱  係  栘搚搙  釥摛柶  奓幰梋  幰  嬥搙愇巵愇枩搝椡涼擓廫忋"
	"彈枖搝怱摓  彯孼氱  搶  僲僼涼  洄  搨  戝挿愇  捁  嶳捁戩  焧  "
	"搩  懇  挍  庻  搶  師嶮娛櫙濅  庻  壩挌壩搊儓  涼摛庻  帥  崌  "
	"摨  暷搨巺廩帄  廳  搾  熿  尵悺梍  嶰岥懌孊挍  廏  嬥搊搼  摛暸"
	"攏  栧  摦  廳椡檆  彯搚摴悺摱  摱  摨  摱  棫棦寧摨媏  庱  嬥摨"
	"忋壓捁  櫡庒擔悺渆怱攧  帩  廸栚壯橷攏  曣  拵  尵攧栘枩徾  檨[]"
	"寠戝抜  洐桼捁淭愯  拡  惣  惔惷撢  嶳儌嫕  嫕澕撛  娉  弬  撛暸"
	"氼塃塤  嬥撛戝帵塏搧檆恖働壓巭  璩  柪  擄  撧  嬥欴廢  攏愳巺婽"
	"揷枖檆亸撿  幵寚晇璋彈  堦  洐僸擇淭洉  僸櫙扖  撪  拵岺++  岥  "
	"泃偟僲乢彈岥洐悈桕  恜樌彈恜恘怱擡  廀  帰  僱洉怱挌櫚崥昤昪娵  "
	"屵儛崱怱擮  慠  慠  暷愯傾  淢惣槼倅椦搚懘堖僣嫢擾  巺撪儉僸僣嫢"
	"擾  嬋扖巌尒枖拵枻  攂  斣  忊  攂  旂  捾  墹攂愇旂攇彈攏  攂  "
	"俤俆旕  敪  漁滻旕  奓澕栘晄晄嶮曅斱杒寧寧巗旕幵撗屓埵岥棫岥彈朸"
	"枅  朸  朸  奓  朻堳巑忕奓棫棫岥尵  拵婽壯暯栴堷廐  恗敀儓儐愱  "
	"敀  敀  敀  擔塒攽  暷敀廙敀愱  敀  朶  敎  朶  愱  扷揤攏喋桭  "
	"檨  憡  愇扟幰  沅  愩  椂  斣  寧檣壩揷徆揷僲乢嬥杮敪  釥  撗敪"
	"闀桭戙滣鎖  桭  敯  栧敯嬨捁怴  崅  拵崌璋  敿  敿  僉亸櫴枖敿斀"
	"嬓杴搳斒墹暥斀  :e  杴  曅斀)e  墹儕揷敿晀  廙焧斪  奓斀鏰  壯暷"
	"壩暸暘暸怘斀柶  柶  斘崄斒嶮斒愇斣  枓拵櫡旕揷儛槨  彈屓涼斾旂  "
	"旕怱屗旕斾  旂  旕暥忋僸昁  涼旂涼巟愇斱昁  旕  擻  寧攂旂  旕  "
	"暏奓鐒  杒]E彙  捠壉懘旂梡  洐栄渆澕斾  揷崺墹斾洐栚梤晇敥  栘搤"
	"斱  櫡橷壓俤闀斾涼渃幗  鋵  寧悺媩昐怱  棦  沅  揷  栘夛彈恇彈唰"
	"巺塏敀  塇渃昞  屨渃昜  悈  昜  昜塟惣帵堖  尵暯娑庂涼挬昪  涼暩"
	"壯彮揷  嬥昪嬥暫帵  拵帄嫑榁岥亪椦悪晲  暫  徛昿晧暘昻  曕暸枅澕"
	"涹姠僴槩僀悺晫  戝揤彈涒晊  摨揷僫嬓涼晅晍  晇  曻  晝嬕暲擔泃  "
	"敧槯晅  晎擏錱堓晇  尵晛帺奓晲  憱僩亰  晅  枅  柍  惓淭柍慍曖浃"
	"柍  棫岥孿悺晽  扂拵戼  楬  戙將岥揷渆氱嬓揷寧斀僱揷寧氱僱氱暅  "
	"愳  挗堜儉  暏  僀儉媿栜嫑晅敧搧栜  媸  媸  媸  暘  椦壩歋  暷暘"
	"暷堎巺暘塉暘槼槯栧帹撪  涹  媢  洜  澢嬓姳  澢淥暩  乤岺澢  栧嵥"
	"斾搚栘仸昐奓鐒  鐒  鐒  噙愇枩儕澢栚栁滪撪斾滸  枓氱涼劉滸  滸  "
	"搧  斀  滸  峏  柶椡彈柶儉淥妚曋媥曫幧曖嬥曖殬曖曖  巭彮梡怽曖  "
	"幵曖宐  敎暘敎搚敎彫淭  敎擔扥儓愱  錇儘曻  曭  屓櫙儘栘岾斀槩晇"
	"嬍  嶳氱嶳氱朁  涼曪曪  曭  曽澕枩僫寧  嫀  曪  嫕  愇曪巺埀曪  "
	"曽  柧  埀  拵  曐  尵曽嬋姣亗  嬥  怘曪捁  朁捁擵  槼櫦澯  棫儘"
	"搚曽彈曽嬓朻朣怱朣  屗曽嫟  朣墹娒曫曨曭擔栚巺曽寧曽渄  尵朸娑幛"
	"奓  嬥柎曽  儘將婯暸僐僸旤  倢槫崟  旤  栘僩媿澕棨  壯渃嬥岥帤椡"
	"焧  焑戜孅  峎  夘櫫栘  斣塇檣  暘嶮杻庤杻愇杻婼涼椦棦  彈枹擔枹"
	"栘澕焫  棦  恀  敎晍敎  栘洍嫑桳栘惓嫑懜慍  槼彫儘揤僰槯枛  栘  "
	"枛  岊  恠  巺拵杻楥僋壓欀  椉  欀  欀  枹  栘  婼枹屓  懘  嶳峛"
	"泘昁泘昁憈  悐  擮  攈  彈彮暷栄巵  栚柉柕澕梉  嶜櫪儉媿梊僆塉柋"
	"晲捁栘嫗彈旸彈椙檏扷梉儘扏崌擔寧柧嶮暷  嬥柤儘捁彈帄媿僸奃曡僋橸"
	"栘涘巺涘柺  帶昐敒柺敎  敎  曡  朣彈巕嶮傕儌栃  朣栚巺悝枹栄壠  "
	"怣彅廫戝嘁崟擔寧栘岺櫙  怘涹洍  屗戝暷恘悽奓栧儘栧怱巺暥F]  櫙恘"
	"僙傗戜  槼  晝栯帹  棦梊洉  揤  櫴  渆焧庂  妝  広  懌璋棫惵塊  "
	"悢  尛  慜  慜  桼  桗  尵慜幵慜儘璋僀塃桱  抝  僫枖桳  涺嶳澘  "
	"垽昐帹  塃寧栘桼桬  酺  廢  廢將揷  僱塃僱扟尵廏熰  攂  悅  峀璋"
	"榄拵僞僋儅挌儂  俆傆尵  榋  梊暸梖  涺椡彈氼扟  涼梡濅  娛  悇  "
	"桞  濅  梤  梤  梕  梕  寧峛嬻愦墹敿岝璋悽栘梕  惣彈尵娛酺  娛  "
	"濅  怘  梸  報  扟寚氼  扟  塇棫塇堎掕  堐  椵  壥  枹  棃  懇暸"
	"塉揷奺  巺奺棇  撗奺愩偟塊  晽  鑼灜娔  娔  鑼  恇尒壯儕巎忎洐暅"
	"栘巕棙栘墹棦墹嬜涼棙棦  僱棦峛憗嬜璋愭搚沅  懖涺槼僯棩  嫗  揷奺"
	"嬥  廩  棷  廩  搧揷廩  暷棫氱惗壒峛棫  楥  錱巚曽TK錱抝僼槴忕  "
	"樀  檆嶳愭氱樀  暷搇濻  嫗  陭  涼樀樀  愭氱検  嵂  尵嫗樀  扷棦"
	"愭氱椷  搧僫巺儓樣  櫴棦栘  煍椦暷慍椦  恇昳幵樣暷慍暷慍幁慍棷  "
	"棦  栠  揷巺暷戝崱  椷  楍  椷  枩椡椞  椷  墹椷僱偟椷  嬥椷娂璁"
	"塉椷塉暲幁  帟椷櫴椦櫴椦焑儕彮椡楍  楍堖涼寭枓怱暷慍楢  壩搶楑  "
	"巺搶憦  楢  幵  嬥搶儘岥嫑  楧  壩屗奓奺懌奺塉楬椡  彈  涼榊墹淥"
	"椙寧暷彈榊  椙  洐塉媿  椙  棾  搚僸棿帹拵陭椙  槼敧幁  僱儓寧椡"
	"嬥儓樣  埾  壯儘尵愩晄惓奓桳椡亪埥  栘櫨廇捁屳枩扷  嫑欥尵戭崅  "
	"櫸  埗  淾  埗  埗  ";

static const char *ro2 =
	"淭  惓櫙晄  僿倢傝儖    堜      僲乢愮杒槰  擕  倢  徾  憟  幧梊"
	"槦  挌僄][  岺媧堦  槼檣嫗  戭  夞妿恖^^擳  櫴恖僀僩僀僇僀忎僀搧"
	"僀恘廦愮夘  槾  幐  屆  暏  嬪  泙  泘挌媑  懡  庨  戭  挍  扂  "
	"昐  桳  梤  栘樃崌嶜岫  尒  後  恖妿巈  柶  酺  棦壚棙  掜  幵  "
	"婏  嫃  孅  橺  嬻  懖  媤櫨廸  徆  惵  戩  斱  晎  栧  檁  櫡  "
	"僐枖慭崌奆  旻  堈  屘  幰  崥  檂  婼  岎  愱  櫧  曧澛柦      "
	"愱  楰  婌  啜  嬆  懼  懼  摱  嫔  榡揷橜  璨  擾  娔  惸      "
	"柌  昳  擄  楉  尩      儖  橷  塒橸孼  柶  崕  桧  塉  慜  敧俆"
	"杒堎儭 ]檆枻櫩  桼檆檆摨桼寧侐檉柶  堦伿檏橽檏尦娉  塒庂枊      "
	"氻  屳  拞  悈  孼  楍  屌  嫗  鈎  橷  錱張栘檣擟檣峜檣俴乿檨槻"
	"恘  僠儕氻儕栜  嫀搧嶜  愩儕氿  棙  涹檭涊  崕  懇  婏  堈  慜搧"
	"姣  槱  洄  憙  昜  橜  橜檭橜搧檭  鐒  惸  恏  恏  嬪椡彚椡媑椡"
	"晇椡涊  嫗椡彆  楯壩愑  憙      渃  孧      璋  僲僼栜恘嫢櫙揷櫙"
	"曖櫙櫙  氿曪僸倲俴儭櫡峛櫡弝櫡婱櫡  丳俴櫡昳嬨廫淥愳擓偣淥廫廫  "
	"敼弝壓槼儭|]栵  僞櫯扟櫯姫  僲丳櫴渃櫴懃櫴壞櫴  櫴巣櫴澠儉  嶲  "
	"嶼  惽  塒巟擔枖    儘挌儘搧儘敧儘擖儘槹儘媿儘夊儘嬕儘槾儘岴儘堯"
	"儘撪儘暘暥儘儘広儘塱儘壜氱儘儘尯儘塟儘峛儘崯儘檣儘怽儘妿儘搝儘弌"
	"儘晅儘曪儘孿儘枩滫埥儘帄儘岎儘嫟儘崌儘師広扅儘惣儘戭儘榁岦  儘峴"
	"壜  変  婓  屷  峏  岶  將  曖  楳  墬  埑  壍  嬻  璋儘枖::戩  "
	"墛  塒  擮  栠  榖  戫  媞  奺  欦  堓  掗  廐  帶  扏  扨  掗  "
	"撿  檂  巋  椇  塆  廘  嵎  壞  榁擔拵  崃  櫧  澛  愑  懓      "
	"杻  楢  氥  婍  塩  崯妏巣  挬  柍  堄  嬛  沌  猬  昳栘崅  擩  "
	"旲  棲          墠  嫿岦塪  尩  婍  庉      嶨      錣  憽      "
	"陽  僐檨殬壔殬椷殬曽殬桳殬屷殬岾殬姫殬埥殬梃殬堳殬愱殬  殬涋殬垼"
	"搚擖搚壓搚嶳搚寚搚嬕搚巭搚晄搚娒槰  戙搚搚旂搚晅搚曪搚堝搚嵂搚峴"
	"搚帄搚涹忋壓搚後搚妏搚曖搚悺搚悺搚垷搚壴搚懖搚朁搚惣搚欴搚濅搚曐"
	"搚塆搚壩搚奀塒焧搚帪搚惓搚巃搚栰搚娫搚嫊搚懜搚墱夡  搚殽搚挊懧  "
	"梚  墋  塨  岫  淎  昳  杗  撥  忞  棿  憇  攧槺摛  旸寧氣  恞  "
	"媣僞氱      儓焑椦梉壥懡晇  戝  戝廫戝俆戝  棫壜枓戝巐戝戝孿涺戝"
	"憇戝幰  廢  墱  彨  櫧  彈姳彈庂彈  僀彈栂  彈斾彈扷彈曣彈埼梤彈"
	"彈淥彈擟挍  変  彈寧嵐彈撨  彈  彈抝彈垻彈恜埗  庢  庢  斱  椦彈"
	"旣  嶮  檌  庛  塒巟彈攏鄟  櫧  忢      昜  娫  娬  嫪  歞  鐒  "
	"抝彈抝彈彈  旲  棅  忟艴    憵  椆  擳巕巕  帤  搝巕堝  嫕娵涺巕"
	"棏  妛  暥巕廀  槼  泘僸泘恇扖  柶      璋  惀          娧  怮  "
	"敎  塇渃塒庂垼  奓  奓  崕悺彨  愱  嬈悺働彫恟  戝嬨洍渃櫴  洐涼"
	"洐斾洐  洐暷洐奓洐  洐涹洐  洐  嶳僫嶳偟嶳搧嶳岊媦  崱  暘嶳嶳彈"
	"嶳桼嶳巵嶳敀嶳暯嶳柉嶳曎嶳愯崌  嶳帥変      嶳峏嶳徰捁  嶳扟亄  "
	"埑  壀  汄  嬥  孅  崺  璋  憟  嶳氱樣  樣  娒寚昳  鈁  旣  婼  "
	"嵎  庛  櫧  巃  復  嬆  搊  媊  橜  崠  棽  媈  鋙      榘  揯  "
	"    尩  <<  岺樃屓  岪攂巵嬓儓嬓嬓幐搝嬓敀嬓    嬓璋嬓壆嬓梃嬓掑"
	"嬓柣嬓殸欀  壒淭嬓摱澠嬓晻嬓++TT淥仈儉  杻涺槼櫴涼梤涼懃涼憡涼壞"
	"涼婛涼焨涼渃涼墿涼巣涼悺涼杗涼幄涼柍涼夝涼鈍涼岣涼璋涼  涼挳    "
	"淢桼僫廫淥  淥              幃  媩  搝媩媩帹朁  欶  抏  帰  尵媩"
	"枓媩儓儐娉  儓  淿壥僲  媑渃僀  渆曽渆惗渆妿渆暏渆夞渆嵂渆涊渆弡"
	"渆  搆  旕  渆  渆峜渆娛渆  悺  嬕  屵  塏  洍  氼彫捈  暘怱戜  "
	"嵼  屆  嬪  擈  撫怱櫚崥扷  敀  暏  暯  墰  塱  孿巙擟怱奺  媥怱"
	"櫛  椡亪屳  岝  師怱帥  寣  弡  愩  摨  梤怱寧  澺  嬶  崲  懇  "
	"徰  堯  帤  柶  梂  棙  欏  槺怱婫  宐  姫  懖  櫨  嵢  廃  挿  "
	"悝  嶮  欥  煡  峜  弔怱廐  帶  惎  愰  崥  懃  涊  柉澕擔氱焨  "
	"婥  崚  婼  寭  尨怱崃  嶑  憅  愱  桹  孖  寴  峃  嶲  巃  巃  "
	"廬  廗  濅  憿  愱  摦  摻  昜  梖  婌      揫  宨  徟  歞  旛  "
	"攏  鑬  柍  岾  墱  婂  夰  夝  嬑  昳  尵  椦  璋  鈍  廀  枮  "
	"棅  嵧  嵧  湏  璋  嶝  汜  楒  淭  曡  曡  曡  滣  滣  滣  恟滣"
	"璋滣滣  愴  媃  滣  屗嶜僉偟僉姳僉儘僉岺僉嵆搧  栵  墹  氻  滣  "
	"梊  捾  搇  敳  壓  晄  梒  娒  怽  搝庤崌庤愜  尵  愯  攓  敿  "
	"晅  暏  曣  嬨椡棫  奺  媑  嫟  塇  孿  庤  忓  懚  儘寧汃  澺  "
	"塒巟擔搚栭  婏  嬘  庢  悅  惂庤櫙  戩  掕  柦  栧  栠  娉  奆  "
	"搶  帷  帶  廮  愮塒栯  檂  梉娛姦対檌  嵎  庛  憅  汜  搰  塇  "
	"愱  浟  幏  愱  塇渃妎  巣  隉  幄  樀  櫑  姶  娉  嬜  樂  岾  "
	"払  鐒  棆  潂  鋙嫇鋙僉惸  幒  戜  氭  昽  棗  慃  淎  揂  旊  "
	"嫇  妝炠艴  浟  巀  擄  巺尵惽  枖  枖働澕  澕  僀澕揷澕岎澕曻  "
	"懇澕梋澕梋澕彯澕嬓澕崅澔悢  橜澕澢巰巺尵妏搇恟搇愇嬕抐  曽扥曽巗"
	"曽棫曽栄曽惗曽廩曽斣曽斣僠儌澷  憗姳擔  擔揤擔樅擔暥栘擔擔擈塱  "
	"擔塊擔栜埨  擔岝怶  擔挍擔婓彂  擔屷擔崘擔扖擔惉愜  愅  旕  孯  "
	"塸  孯  愰  濅  柣  扷  恑  隉  撝  澢擔壺  樀  垽  栔  淎  峀  "
	"媊  嫟  俤岥怽滣擔擋寧弌寧椙懘  栔  棿  塉忊儂  巗枛擳栘栘擖栘椡"
	"栘搧栘姳栘屓栘岺栘淭栘嶳栘枩栘墹栘  栘岞栘梊栘彮栘暘栘曽栘屗栘彙"
	"栘淥濽壛栘壜栘夳懇  栘扅栘櫡栘嬪栘妿栘撫栘愃栘巵栘弌栘曪栘晅栘棫"
	"栘塟栘慭栘姳栘嫥栘塇栘慍栘氿栘峫栘帄栘廩栘懚栘柎栘摉栘妏栘澺栘捁"
	"栘崘栘堯栘涏栘澘栘撨栘掛栘氭栘暫栘泃椦杴栘楥椦壓栘槺栘幍栘孨栘嫕"
	"栘懘栘庂濺  栘崙栘寯栘壀栘嬻崺  栘崹栘滬栘廆栘堯栘廸栘彣栘濺栘  "
	"栘抦栘戩栘彯栘擮栘晎栘暲栘栧栘揟栘帄栘樣栘擳栘奆栘層栘廐栘帹栘宊"
	"栘愹栘幰栘恟栘掗栘娉椦柕栘栯栘檂栘曽栘瀓栘幒栘悽栘嶮塰  栘婼栘姣"
	"栘崅栘峷栘崪栘嵎栘姦栘嶑栘搰栘塇栘斒栘斮栘壩栘愱栘柣栘澯栘梕栘棷"
	"栘棾栘妔妝  栘渃栘孿捙  栘嶩妏搇栘巃栘廬栘悐栘櫧栘愂栘憙栘愱椦戝"
	"栘枾栘枿栘塱栘楰栘姼栘娧栘婌栘嵟栘徎栘焳栘銨栘搊栘摱栘隉栘旤栘捁"
	"栘尵栘堄栘宧栘曻栘橜栘殽栘鐒栘烜栘娤栘櫤栘璋栘擩栘昽栘栔栘墢栘昳"
	"栘炠栘妝灜鑳栘楌栘塪栘潷栘  栘塉栘尵栘棗娛渃栘娤後寚婓寚搻  婏寚"
	"堸  寚  塒寚寭寚櫧寚塇寚嫊寚橜寚鋙寚璋寚巘涒梉枩焑枖焑氼焑渃焑墰"
	"焑泃焑滬焑棫焑堳焑濅焑氥焑歞焑昽焑淭焑淭檣枖焧  攧焧櫧焧塏仈枅廩"
	"彮栄栄媮栄  栄  栄墛杻栄樂栄朣柉亖偟焹暘焹場焹暷岺悈嶳  搚  墹  "
	"嬕  屳  巭  怱  巗  暘  擔  斀  枖  栘  悽  墰  峅  屆  巐  場  "
	"愃  妿  泙  愯  揷  朢  柉  暯  栚  埼  峴掦櫛  寣  崌  岝  庨  "
	"弡  擆擛惣  楍  姰  寧  岹  堯  汃  愜煁墑  掜  氭  擔搚墏  僔儕"
	"暷愳敓  懘  嬥  屌  嶆  懖  煍徏彯  啷  嵢  煍愅滬  廆  墬  搚橷"
	"樣  弝  堓  惣搚壵  汈  唰  峜  孯  煍扷廐  煍煏愹  帶  掄  攓  "
	"煟嵐柺  杣  枮  檂  曽巕巋  後  朄嶮峎煩殬  嵣  怞  嶑  憅  櫿  "
	"塒  寧懽搨  塝愱媰澯柣  崰  婛  熖  椳梂嫋  垼  洅  嶲  懇寚懷  "
	"挘  瀶  塲  嫢儉阞  隉  洐  儂寧巭  巭  恞  愽  愽  憗  峌  摱  "
	"斣  渄  垷  楑  樀  墱  姴  煍昳岾  尵  奓  楇  惸          帰  "
	"擩  昽  杔  栔  檕  怰  嫠  朶  梴  棲  椂      姴  挅  楌  岣  "
	"沌  郵淺鑼  澥  崡楉巺尵梉壩壩彮壩檆壩檆壩嫄壩撫壩暩壩曪壩場媥  "
	"壩忓壩奺惓  壩氱壩崺壩棫壩汈嫄枻鄦  嬪  壩  壩峜壩唰壩濅壩廳壩鄭"
	"壩懅壩峷壩堁澛  壩栧婌  壩淭壩隉壩撝壩斣壩樀壩墱壩毷壩悑壩払壩岫"
	"壩娉廗璋壩炠壩岣壩鑼暟  儓洑捾攂桭  堊  儊槯喋妿=|  喃  喃殽曅滬"
	"曅攦媿巵媿屷媿壯棙媿媿亪媿崅楽  媿攦媿媊栟  嵥  塏  拞  壩  峛  "
	"暏  奺  嵂  岎  嫹  儘寧澘  婏  橺  惵  徆  懖  岒  帶  惎  堌  "
	"崪  洅  敎  崟將櫸  慭  鍐  擩  廱  憀  將  悾  壛  戙  洉  旂  "
	"敀  帹  扂  奺  垷  椙  榊  屨  屷  旕  朄  僐枖孯  昁  嫢涊朻  "
	"檂  曮  婼  墹奓攏  墹娛嬐  復  旤  鐒嬍壞  棿  帱  彈  氿塟恏塟"
	"姠廫姠愮姠岞姠撛姠暘姠栄姠昐姠巔姠惣姠廐姠椥櫧姠愱姠柌姠姠  姠  "
	"彯娒峏惗儅梡揷挌僣揷揷夘揷堜揷晇揷渃揷儉揷儉揷堖揷帪揷奺揷彂揷梋"
	"揷婏揷彯嫯  揷氭揷庻忯  揷  椲  涼挌涼媣涼嶳涼夘涼栟涼壛涼娒涼尯"
	"涼崯涼妿涼扷涼搤涼曪涼埼涼慡涼梤涼涊涼巙涼斲涼垻涼埾涼屌涼懖涼墛"
	"涼斱杻  杻  涼晽涼濅涼檂涼嶮涼媠涼愐涼憅涼斒涼棷涼復涼椵涼嵢涼娫"
	"涼幄涼櫑涼揳涼漭涼媈涼梴涼璋涼  涼愊涼楌涼慛涼璋涼揯    釥揤釥焧"
	"敀僸敀橷敀斀敀戝敀岎敀姰敀崘愅敀敀姣旂曪堯旂孯旂旂孯鋶旂槹嶮嫀嶮"
	"梤嶮崌嶮滬嶮沅嶮悈嶮錱嶮搾嶮摖嶮栚檃栚洍栚彮栚  栚尯栚擈巪嬶崯栚"
	"栚崯栚枹晇栚栚柎栚掜栚埑栚橺栚憱栚惵栚斱栚  栚岾栚幰栚愩崃  柣  "
	"摪  栚  栚姼栚婱栚垽栚璋栚橜栚屰栚尵栚栔嶝惽捈昳栚鍐柕崱儉栴栴埾"
	"愇岺愇愗愇斾愇淎愇妿愇漭愇孿愇懖愇壴攇愇愇朁愇棫愇淿愇擔愇掑愇恟"
	"愇涊愇姣愇崪愇嵎愇慍愇揥愇攏愇澯愇昳愇惡愇愑愇愱愇隉愇搊愇墱愇媊"
	"愇醕愇媈愇椦愇炠帵枻帵巌帵巵帵弌帵撫帵昁帵淭帵懘帵淿帵宊帵堯帵婌"
	"帵惸帵歞帵朙帵艴拵  峛拵愮儓壯斾壯墰壯嫄壯  壯枛壯澺壯徰壯懘壯捈"
	"壯廃壯夞帵夞壯檉壯塒壯崅壯堯壯梕壯宐壯嵰壯殽壯嵨壯媫壯婽壯艴寠媩"
	"寠堜寠梒寠僞寠挍寠孨寠崘寠欴寠  寠娛寠嵢寠曻寠憀寠棽寠悑寠嫣寠壯"
	"棫廫棫愮棫暘棫栄棫愯棫挌棫  棫昐棫後棫懇棫堈棫椥娵  栜  捾  攂  "
	"壛  愯  惗  戜  斆  杮  栴  嫥  鉃  涷淥弡  洑  慡  愭  墑  楥  "
	"汃  尒  嶌  澘  惉  涋  漎  嬠  崺  嫅  嬻  摎  滬  涒  啷  憟  "
	"暈  汃  峜  岒  娒寚欦  娉  檌  巘  悐  柂  崺  孖  棿  愑  懓  "
	"挙  昄  埀  椑  嵢  鄟  婱  墿  懼  惣憗尵  沌  摎橜氭  娔  悢  "
	"婙  棷  熿  熿  棅  敵  敵  隇  棧  暷廫暷斾暷屗墱枩暷崌師暷暷帶"
	"暷摨暷昐暷峏僞暷暷椑暷椙暷懖暷廆暷壴暷廮暷恟暷壠暷梡暷杻暷敎姛  "
	"暷廀暷漭暷嶨暷  巺偟巺槹巺悺巺塢巺斾巺暥巺檆巺峀嶥巺巺悽巺戜巺挌"
	"巺敿巺儛巺岝巺峴巺  巺廭擛巺巺塯巺涹巺涊巺廏巺澘巺懨巺楥巺擡巺婏"
	"屗巺巺姫巺嵮巺酼巺戩巺滬巺壎巺廃巺娛涘宯巺樣巺栠巺姱巺欦巺帹巺悽"
	"巺抜巺抳幯  巺崹巺埿巺塿導宯巺嵣巺嵎廲  巺怞巺怶巺捛巺  巺渃巺嫮"
	"杻巺巺欀巺昜巺曵巺楰巺椵巺楢巺塤巺栧巺嶶巺隉巺斣巺樀巺岾巺慭巺  "
	"巺宲巺廀巺惸巺惸巺昽巺恏巺娔寢暸巺巀巺嫣巺杗峣暸巺塪巺柶巺滣巺滣"
	"撆巺巺棗娛岺娛氻娛  娛奓娛  娛撥娛璋檆儊姳  檆朣晄  屆  柉  墏  "
	"戩  椦  摙  對  孎  枊  妚攏妚婏梤橸梤  嵎塏梤巵梤椷梤孨梤  梤  "
	"梤旤梤旤梤樂梤  梤尵巟塇櫨塇棫塇崌塇梤塇旕塇慜塇滸塇墸塇隉塇斣旘"
	"榁巪榁栄榁帄壯枹阄塢阄攂阄楥阄彆阄怞帹壩帹巭帹塊帹椷帹愩帹桼庢  "
	"抦帹帹掕帹淥廬帹惡帹帹  帹  帹擩帹  儓僉僸沅挿沅沅愳寧岺寧朣寧搚"
	"寧撪寧擔寧栟寧峛寧旸寧撫寧巵寧桼寧槨寧敿寧塱寧氿寧岝寧涊寧澘寧扖"
	"寧曖寧栭寧嵍寧揟寧斱寧旕寧晎寧涹寧寶寧巚寧惎寧涊寧鋕寧嶮寧榄寧愱"
	"寧澯寧椃寧涊寧殸寧愥寧拏寧幒寧濅寧峷寧斣寧懖寧慭寧嵍寧尵寧揳寧鐒"
	"寧婂寧橜寧惸寧廀寧墠寧憀寧妺寧岣寧憼巺擏恇曡幒  帄恅塒恖塒淥塒弔"
	"塒抝塒榋塒璋崌愩愩巵鋛曖廙岞廙曽廙壜廙桼廙泃廙憅廙櫿廙愥廙憘廙摱"
	"廙媊廙殽廙栔廙楧廙岣廙屗妚嵂朙怓洠  ++槯庂  朣  尦  焧  庂  暘  "
	"埲  嫄  嬪  檉  妿  搤  曣  枅  斆  晅  暯  曪  塊  栚  枛  棫  "
	"場  夞  奺  涺  庨  弡  擛  懚  崌  暁  鋳  柤  搧亪埵  墑  変  "
	"娷  汃  涊  屶  嵐  彆  氠  梋拑揺  摛  擡  廏  棙  椙  墏  愰  "
	"拞墹崺  廸  懖  徏  嵢  惵  涒  挿  攇  旕  煝錂朅  朁  戝淥鋕  "
	"椊  椦  俤僐壢  欥  欥  姤  孯  層  鋶  抜  掗  攂  曐  鈁  栺  "
	"巤  欴  墺  懢嶮寭  崅  錇嬪嵗  挊榁庛  廋  怞  恅  惾  崺  澯  "
	"嵳  廻  愱  弾  嶲  慲  懓  懷  櫞  塇渃灆  弚  隉  憗  恞  怱  "
	"巭  桺  壏  焑桕慭  榡揷嫑  柌巰沌  殽  恏  楰澕旝  鐒  梐  棆  "
	"椗  阄愄惸  憼  幒  杄  阄鈁寍幏炠  阾  墆  錎  壯嫑昿  棅  栧璋"
	"岣  棿  慛  銂  梾  忋幍嬕巗錱暥崋屨錱墭拵  拵堷拵岞拵嶳拵搇拵撪"
	"拵僉拵娒拵媢拵屆拵妿拵桼拵椷拵漭拵曪拵夞拵愩拵杴拵嫟拵岎拵庨拵榁"
	"拵墑拵尒拵屶拵櫙拵扖拵橻拵墑拵泃拵梋拵酺拵棙拵堈拵埗拵姫拵惵拵愅"
	"拵廃拵旕拵揷拵堓拵欴拵壢拵堈拵層拵峜拵僫拵氱拵滸拵檂拵巕拵濅拵陠"
	"寀  拵柣拵榊拵澛拵幓拵搤拵棪拵忢拵璋拵幫拵幏拵摪拵枊拵敎拵楰拵隉"
	"拵昳拵斣拵夝鍣寚拵尵拵惞拵醕拵杬拵  拵塰拵惽拵廀拵弔拵娉宄嶮拵  "
	"拵  拵  拵巺寣塏寣恘峴尯峴屷峴  峴璋僱渃垼  崱堖垼  僱擔僱恜逖擟"
	"僱撪僱氻僱渃僱扷僱洉僱敀僱敿僱曪姖廮曣堖僱孿僱暁忋壓僱峴堖檊媮堖"
	"僱孨氠堖棤  遢孴僱堈旕堖僱斱僱嬓僱嵢僱孯僱滸僱曐堖  壏  僱怞僱戅"
	"僱屨僱嫮昞  幏堖僱廗僱楰僱歞僱扨僱醕鐒堖僱廀僱娔僱媑僱曁僱恊僱鑼"
	"僱潷檏  鍳憗鍳曻鍳攏尒  尒愯尒涋尒幰尒檂尒姣尒檌尒  妎  棗  尒嫣"
	"尒璋妏塟妏崯妏巵妏梤妏濅妏鍐尵僩尵岊尵姳尵岺尵壔尵夊尵撪尵壜尵屆"
	"尵妿尵戜尵巵尵  尵奃尵婋尵岪尵弡尵庨尵挍尵阄尵枅尵夲尵嫸尵崘尵酺"
	"尵徰尵涋尵嫕尵啷尵塒尵掕尵瀓尵壒尵奆尵欥尵梃尵媠尵愰尵孯尵晽尵滸"
	"尵鋕尵欶尵姦尵塿尵檃尵揷尵昁尵澯尵娛尵櫧尵妚尵惡尵彜尵欀尵敎尵壺"
	"尵啜尵婔尵柕尵搊尵懼尵懼尵憗尵  尵昳尵鐒尵岾尵尛尵鋙尵嫣尵墠璋扤"
	"尵柶尵艴尵滣尵璋尵巀扟夊奞扟扟  嶳摛摛埗寴摛桯摛晄椆娉対娉幰渃  "
	"娑嵥娑彚娑奺娑媥娑昐娑棦娑橺娑斾娑斾娑敎奓滣奓弬奓崱奓戜奓崯奓擉"
	"奓擉奓朢攦  奓  奓滬攦  奓樢奓姦奓寭奓愱奓幏奓澛奓巀奓晲奓栍奓尵"
	"奓岫奓惸奓曡奓彲奓昳奓嫣愒斀愒幰擵  憱係憱捒憱徰懌巟懌巭懌晇懌壛"
	"懌嶜懌愇懌幐懌旂懌將懌婋懌杴懌嵂懌愭懌嬊懌懇懌椙懌憱懌壥懌嫃懌滬"
	"懌抦懌廮懌廳懌檂懌桬懌  懌姦懌嵎懌憅懌愐懌塒懌愂懌廬懌弾懌廆懌椉"
	"懌昄懌櫸懌懜懌旤懌昳懌挊懌鍐懌鐒懌惸懌氭懌幙懌揂懌恛懌栧懌鏦懌汜"
	"恎媩恎杮恎朙恎濻恎旤恎婂恎滀幵偟幵栵幵  幵幐幵壜幵渃幵幃幵帄幵奺"
	"幵涊幵栯幵庢幵柶幵酼幵枖幵椉幵椉幵晇幵憈幵揷幵氱幵逋幵崚幵揥幵愥"
	"幵愱幵幁幵嫪幵姶幵廀幵炠幵楌幵岣恏  洐恏恏懇恏  恏尵堦  拞  檆  "
	"徖  桼  奜  帰  夞  岪  枓  惣  媮  弰  堯  徰  掓  壩  塝  梺  "
	"埾  搚橷恏  涹  妷  僐枖峜  廢  撗  掑  檂  撿  檌  屨  澛  撠  "
	"隉  銨  嵰  夝  鄅  漭  寖  曈  曈  梾  撛  娒  媢  彚  掓  扟  "
	"屗攂泃  欥  鋶  夞  歞  暷慍撗挌撗洍撗焧撗娒撗壯撗柤撗堢撗掓撗愄"
	"撗懖撗椦撗嶮撗堛撗嶮撗渃撗娉撗朙撗鄭撗艴撗  壯桼壯岾椥  嬥搧嬥敧"
	"嬥敧嬥椡嬥恘嬥嵆嬥栫嬥庂嬥嬕嬥彮嬥広嬥塏嬥斀嬥滧嬥娒嬥嫄嬥尯嬥嬪"
	"嬥泙嬥埼嬥揷嬥曪嬥愇揃峴嬥庨嬥慡嬥愩嬥塊嬥汃嬥廏嬥徰嬥鋳嬥槺嬥埗"
	"嬥嫗嬥屌嬥酼嬥滬嬥啷嬥枖嬥朏嬥壴嬥晲嬥枖嬥峜嬥欦嬥檂嬥恟嬥塿嬥崅"
	"嬥崃嬥梕嬥憲嬥幁嬥寴嬥巃嬥廻嬥洅嬥懓嬥欀嬥渃嬥楢嬥楰嬥湨嬥憗嬥撝"
	"嬥隉嬥斣嬥樀嬥垼嬥璨嬥滣嬥滣嬥醕嬥堯嬥  嬥氭嬥淎嬥炠嬥椂嬥憀嬥岣"
	"嬥屗嬥隇嬥璋嬥汜嬥巀嬥巀嬥梾嬥巺嬥惽嬥  栧堦栧壓栧嶳栧暥栧悈栧峛"
	"栧巗栧嬍栧孿栧嫟栧楥栧墬栧塒栧墏栧埥栧妶栧愩栧廘栧幰栧瀓栧  栧岵"
	"栧攏栧  栧歞栧払栧鐒愮  栵  尦  巭  旂  昐  桳  暩  塒  汃  彙搚"
	"汃  曕  庻  悅  庢  峜  塿  堳  婼  橜  悑  塀  攏  巺  棿  儓悈"
	"璁  俤恇妿璋璋  栴璋涺璋僱廤懖璋塉璋廃璋塉曪塉徰塉墑塉煆塉橺塉彣"
	"塉煘塉旕塉椦塉塸塉棷塉堹塉嶶塉鐒塉惸塉婕塉墆塤戇塉涋塉楌塤垽惵啷"
	"崘旕柺曪柺尒柺墋妚椡妚嵆妚恘妚撪妚墰妚扷妚旂妚枛妚暩妚孿妚杴妚忋"
	"妚孊妚櫛妚廐妚廮妚洄妚梡妚払妚慗妚曁儐儛梃塒旕  惸桕惸桕壒尒壒彚"
	"壒庂槾暸岞暸涊暸恇暸媑暸娷暸撁暸壥暸旻暸巚暸樂暸擔暸昿斱岣暸璋暸"
	"汜暸壓晽棫晽晽戜晽嬶昜晽晽昜將晽怘撛怘氼怘岎怘岦怘懨怘曖怘梋怘塒"
	"怘朏怘滬怘墛怘涹怘層怘焑怘婼怘棷怘嶮怘墹怘欀怘氥怘婱怘婔怘隉怘扚"
	"怘錴嬨庱庱埥崄氱攏枖檘攏攏暥攏巐攏巎攏泙攏戜攏搝攏堝攏岎攏奺攏廈"
	"攏澺攏怹攏桼攏懘攏璋攏涹攏滸攏嵡攏攁攏櫧攏嶲攏曟攏昜攏椵攏嫪攏隉"
	"攏岾攏橜攏庢攏岣攏檅攏艴攏璋攏亪攏楉崪姳崪焧崪奺崪斱崪楰崪鍐崪嵍"
	"崪朙崅昳挿渃闀栫闀曽闀栄闀檉闀彚闀氱闀暏闀曪闀嬋闀媑闀徏闀欀闀恵"
	"闀垼闀昽闀憀||++棣巗棣嫟棣橺棣悺棣  嫢僸儘檆敀婼婼將埾婼婼悝婼椉"
	"婼  婼墋嫑曽嫑撫嫑暯嫑曪嫑愇嫑搤嫑埨嫑婋嫑巪嫑媥嫑宯嫑嵐嫑徰嫑曖"
	"嫑棙嫑婓嫑酺嫑堈嫑橺嫑崺嫑酼嫑旕嫑嶲嫑墬嫑屨嫑擮嫑枖嫑欦嫑峜嫑巚"
	"嫑廢嫑弔嫑悽嫑氱嫑瀓嫑埿嫑嶮嫑嶮嫑  嫑巘嫑棷嫑恄嫑峃嫑澛嫑復嫑昜"
	"嫑婌嫑慭嫑朙嫑梴嫑岣捁檣捁檣擖捁夊捁櫴捁櫴捁捁氻洍捁寠捁墰捁捁壩"
	"屆捁巵捁帄捁捁泙椷捁岎捁崌捁柎捁峴捁帹捁変捁変捁妏捁寧捁涋捁奓捁"
	"愄捁嫕捁搶捁搶捁斱捁栭捁欥捁孯捁捁  塇捁捁  杶捁崪捁庛捁愐捁崃捁"
	"恀捁娛捁幏捁弾捁柕捁徟捁斣捁樀捁捁  塪捁璋捁巺捁愯恾阞欦阞娔幁  "
	"幁庡幁暷幁屶幁懘幁嬠    幁幩樢氱阭晇敒晇阭  阭曪杻旕墿  壯栜阾愯"
	"阾嬜崟崱崟弌崟愯崟梒崟媑崟嫗崟彯崟壒崟旝崟墋崟嫣嬓  陜  陜曖桕  "
	"澛陠澢陠摛旂屰搤酼梡憀桼旲姳惸  帟  陱僸陱嬪陱妿陱彚陱椷陱嵂陱宊"
	"陱屷陱懌陱壆陱鈀陱欥崌棿婽  崌樣嬆  崃  僞娛僞娛鈍  恇枻";

/* japanese.c */
